/**
 * Copyright (c) 2025 Dominic Masters
 * 
 * This software is released under the MIT License.
 * https://opensource.org/licenses/MIT
 */

#pragma once
#include "dusk.h"

#define TILE_WIDTH_HEIGHT 16

typedef uint8_t tile_t;

typedef enum {
  TILE_SOLID_NONE = 0,
  TILE_SOLID_FULL = 1,
  TILE_SOLID_TRIANGLE_TOP_RIGHT = 2,
  TILE_SOLID_TRIANGLE_TOP_LEFT = 3,
  TILE_SOLID_TRIANGLE_BOTTOM_RIGHT = 4,
  TILE_SOLID_TRIANGLE_BOTTOM_LEFT = 5,
} tilesolidtype_t;

typedef struct {
  tilesolidtype_t solidType;
} tilemeta_t;

static const tilemeta_t TILE_META_DATA[] = {
  {TILE_SOLID_NONE}, // 0
  {TILE_SOLID_NONE}, // 1
  {TILE_SOLID_NONE}, // 2
  {TILE_SOLID_NONE}, // 3
  {TILE_SOLID_NONE}, // 4
  {TILE_SOLID_NONE}, // 5
  {TILE_SOLID_NONE}, // 6
  {TILE_SOLID_NONE}, // 7
  {TILE_SOLID_NONE}, // 8
  {TILE_SOLID_NONE}, // 9
  {TILE_SOLID_NONE}, // 10
  {TILE_SOLID_NONE}, // 11
  {TILE_SOLID_NONE}, // 12
  {TILE_SOLID_NONE}, // 13
  {TILE_SOLID_NONE}, // 14
  {TILE_SOLID_NONE}, // 15
  {TILE_SOLID_NONE}, // 16
  {TILE_SOLID_NONE}, // 17
  {TILE_SOLID_FULL}, // 18
  {TILE_SOLID_FULL}, // 19
  {TILE_SOLID_FULL}, // 19
};

#define TILE_META_DATA_COUNT (sizeof(TILE_META_DATA) / sizeof(tilemeta_t))